diff --git a/src/config.h.cmake b/src/config.h.cmake
index 17941f62a..acc22be28 100644
--- a/src/config.h.cmake
+++ b/src/config.h.cmake
@@ -103,7 +103,8 @@
 /* Define as const if the declaration of iconv() needs const. */
 #cmakedefine ICONV_CONST
 
-/* Define to the sub-directory where libtool stores uninstalled libraries. */
+/* Define to the sub-directory in which libtool stores uninstalled libraries.
+   */
 #cmakedefine LT_OBJDIR
 
 /* Name of package */
diff --git a/src/gd.c b/src/gd.c
index 23afe854d..e1b346ecf 100644
--- a/src/gd.c
+++ b/src/gd.c
@@ -2267,6 +2267,16 @@ BGD_DECLARE(void) gdImageRectangle (gdImagePtr im, int x1, int y1, int x2, int y
 		return;
 	}
 
+	if (x1 == x2 && y1 == y2) {
+		gdImageSetPixel(im, x1, y1, color);
+		return;
+	}
+
+	if (x1 == x2 || y1 == y2) {
+		gdImageLine(im, x1, y1, x2, y2, color);
+		return;
+	}
+
 	if (y2 < y1) {
 		int t = y1;
 		y1 = y2;
diff --git a/tests/gdimagerectangle/Makemodule.am b/tests/gdimagerectangle/Makemodule.am
index d046e4674..4175ca598 100644
--- a/tests/gdimagerectangle/Makemodule.am
+++ b/tests/gdimagerectangle/Makemodule.am
@@ -4,5 +4,4 @@ libgd_test_programs += \
 	gdimagerectangle/github_bug_00172
 
 EXTRA_DIST += \
-	gdimagerectangle/CMakeLists.txt \
-	gdimagerectangle/github_bug_00172_exp.png
+	gdimagerectangle/CMakeLists.txt
diff --git a/tests/gdimagerectangle/github_bug_00172.c b/tests/gdimagerectangle/github_bug_00172.c
index 123088929..77771cd22 100644
--- a/tests/gdimagerectangle/github_bug_00172.c
+++ b/tests/gdimagerectangle/github_bug_00172.c
@@ -1,51 +1,47 @@
 #include <stdio.h>
 #include "gd.h"
-#include "gdfontg.h"
+
 #include "gdtest.h"
 
 int main() {
 	gdImagePtr im;
-	int black, red;
-	char path[1024];
+	int black, white;
 	int error = 0;
-
-	im = gdImageCreate(400, 200);
+	int xs = 300, xe = 350, i;
+	im = gdImageCreateTrueColor(400, 200);
 
 	if (im == NULL) {
 		gdTestErrorMsg("gdImageCreate failed.\n");
 		return 1;
 	}
 
-	gdImageColorAllocate(im, 255,255,255);
+	white = gdImageColorAllocate(im, 255,255,255);
 	black = gdImageColorAllocate(im, 0,0,0);
-	red = gdImageColorAllocate(im, 255,0,0);
-	gdImageString(im, gdFontGetGiant(), 5, 5,
-	              (unsigned char *) "RECTANGLES", black);
-	gdImageString(im, gdFontGetGiant(), 150, 5,
-	              (unsigned char *) "Filled", black);
-	gdImageString(im, gdFontGetGiant(), 300, 5,
-	              (unsigned char *) "Unfilled", black);
-	gdImageString(im, gdFontGetGiant(), 5, 75,
-	              (unsigned char *) "Height=0", black);
-	gdImageString(im, gdFontGetGiant(), 5, 145,
-	              (unsigned char *) "Width=0", black);
-	gdImageFilledRectangle(im, 150, 95, 200, 95, black);
-	gdImageRectangle(im, 300, 95, 350, 95, black);
-	gdImageSetPixel(im, 300, 94, red);
-	gdImageSetPixel(im, 350, 94, red);
-
-	gdImageFilledRectangle(im, 175, 125, 175, 175, black);
-	gdImageRectangle(im, 325, 125, 325, 175, black);
-	gdImageSetPixel(im, 300, 94, red);
-	gdImageSetPixel(im, 350, 94, red);
-	gdImageEllipse(im, 325, 95, 90, 50, red);
-
-
-
-	sprintf(path, "%s/gdimagerectangle/%s", GDTEST_TOP_DIR, "github_bug_00172_exp.png");
-	if (!gdAssertImageEqualsToFile(path, im)) {
-		error |= 1;
+
+	gdImageFilledRectangle(im, 0, 0, 400,200, white);
+
+	gdImageRectangle(im, xs, 95, xe, 95, black);
+
+	for (i = xs; i <= xe; i++) {
+		int c = gdImageGetPixel(im, i, 94);
+		if (c != white) {
+			error |=1;
+		}
+	}
+	for (i = xs; i <= xe; i++) {
+		int c = gdImageGetPixel(im, i, 95);
+		if (c != black) {
+			error |=1;
+		}
+	}
+	for (i = xs; i <= xe; i++) {
+		int c = gdImageGetPixel(im, i, 96);
+		if (c != white) {
+			error |=1;
+		}
 	}
+	FILE *fp = fopen("a.png", "wb");
+	gdImagePng(im, fp);
 	gdImageDestroy(im);
 
 	return error;
diff --git a/tests/gdimagerectangle/github_bug_00172_exp.png b/tests/gdimagerectangle/github_bug_00172_exp.png
deleted file mode 100644
index 1e37e19b5..000000000
Binary files a/tests/gdimagerectangle/github_bug_00172_exp.png and /dev/null differ
